.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

FILE_BEGIN		EQU	0
FILE_END		EQU	2
FILE_SHARE_READ		EQU	1h
GENERIC_READ		EQU	80000000h
FILE_FLAG_RANDOM_ACCESS	EQU	10000000h
OPEN_EXISTING		EQU	3
INVALID_HANDLE_VALUE	EQU	-1

extrn	closesocket	: PROC
extrn	send		: PROC
extrn	CreateFileA	: PROC
extrn	ReadFile	: PROC
extrn	CloseHandle	: PROC
extrn	SetFilePointer	: PROC
extrn	SendMessageA	: PROC
extrn	WSAAsyncSelect	: PROC
extrn	HeapAlloc	: PROC
extrn	HeapFree	: PROC

extrn	MainWnd		: DWORD
extrn	SendFile_Data	: DWORD
extrn	Memory_Heap	: DWORD

.Data
	FileHandle	DD	?
	len		DD	?
	SendFileBuffer	DD	0
	BufSize		DD	?
.Code

; ready to send file to a client?

PUBLIC		Msg_SendFileProc
Msg_SendFileProc	PROC, hwnd:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
	mov	edi, wmsg
	sub	edi, MSG_SENDFILE
	imul	edi, SENDFILEDATA_
	add	edi, SendFile_Data

	mov	eax, lParam
	cmp	ax, FD_WRITE
	je	@@SENDFILE_WRITE
	cmp	ax, FD_CLOSE
	jne	@@SendFileProc_Ret

;*******SENDFILE: FD_CLOSE*******
	call	closesocket, [edi].sendfile_sock
	mov	[edi].sendfile_sock, -1
@@SendFileProc_Ret:
	ret

;*******SENDFILE: FD_READ********
@@SENDFILE_WRITE:
	call	CreateFileA, edi, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, 0
	cmp	eax, INVALID_HANDLE_VALUE
	je	@@SENDFILE_FAIL
	mov	FileHandle, eax

	call	SetFilePointer, eax, 0, 0, FILE_END
	cmp	eax, 0FFFFFFFFh
	je	@@SENDFILE_FAIL_CLOSE
	mov	BufSize, eax
	
	call	HeapAlloc, Memory_Heap, 0, eax
	or	eax, eax
	jz	@@SENDFILE_FAIL_CLOSE
	mov	SendFileBuffer, eax

	call	SetFilePointer, FileHandle, 0, 0, FILE_BEGIN
	cmp	eax, 0FFFFFFFFh
	je	@@SENDFILE_FAIL_FREE

	call	ReadFile, FileHandle, SendFileBuffer, BufSize, OFFSET len, 0
	or	eax, eax
	jz	@@SENDFILE_FAIL_FREE
	cmp	len, 0
	je	@@SENDFILE_FAIL_FREE

	call	send, [edi].sendfile_sock, SendFileBuffer, len, 0

@@SENDFILE_FAIL_FREE:
	call	HeapFree, Memory_Heap, 0, SendFileBuffer
@@SENDFILE_FAIL_CLOSE:
	call	CloseHandle, FileHandle
@@SENDFILE_FAIL:
	call	SendMessageA, hwnd, wmsg, 0, FD_CLOSE
	ret
Msg_SendFileProc	ENDP

END
