.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

extrn	lstrcpyn		: PROC
extrn	socket			: PROC
extrn	closesocket		: PROC
extrn	connect			: PROC
extrn	WSAAsyncSelect		: PROC
extrn	HeapAlloc		: PROC

extrn	MainWnd			: DWORD
extrn	Memory_Heap		: DWORD

.Data
	SendFile_Data		DD		0

	CurSendFileData		DD		?
	CurSendFileID		DD		?
	saddr			SOCKADDR	?

PUBLIC	SendFile_Data
PUBLIC	saddr

.Code

; did someone request me to send file out ?

PUBLIC	SendFile
SendFile	PROC, file:DWORD, ipaddress:DWORD, port:DWORD
	cmp	SendFile_Data, 0
	jne	@@SendFileBypassAlloc

	call	HeapAlloc, Memory_Heap, HEAP_GENERATE_EXCEPTIONS, MAX_SENDFILE*SENDFILEDATA_
	or	eax, eax
	jz	@@SendFile_FAIL
	mov	SendFile_Data, eax

	mov	edi, eax
	xor	ebx, ebx
	mov	ecx, MAX_SENDFILE
@@InitSendFileData:
	mov	[edi+ebx].sendfile_sock, -1
	add	ebx, SENDFILEDATA_
	dec	ecx
	jnz	@@InitSendFileData

@@SendFileBypassAlloc:

	mov	edi, SendFile_Data
	xor	ebx, ebx
	xor	ecx, ecx
@@FindFreeSendFile:
	cmp	[edi+ebx].sendfile_sock, -1
	je	@@FoundFreeSendFile
	add	ebx, SENDFILEDATA_
	inc	ecx
	cmp	ecx, MAX_SENDFILE
	jb	@@FindFreeSendFile
	jmp	@@SendFile_FAIL

@@FoundFreeSendFile:
	add	edi, ebx
	mov	CurSendFileID, ecx
	mov	CurSendFileData, edi

	mov	eax, ipaddress
	mov	ebx, port

	mov	DWORD PTR saddr.sa_data[2], eax
	mov	BYTE PTR saddr.sa_data[0], bh
	mov	BYTE PTR saddr.sa_data[1], bl
	mov	saddr.sa_family, AF_INET

	call	socket, AF_INET, SOCK_STREAM, IPPROTO_TCP
	mov	[edi].sendfile_sock, eax
	call	connect, eax, OFFSET saddr, SOCKADDR_
	cmp	eax, SOCKET_ERROR
	jne	@@SendFile_1

@@SendFile_FAIL_closesocket:
	call	closesocket, [edi].sendfile_sock
	mov	[edi].sendfile_sock, -1
	jmp	@@SendFile_FAIL

@@SendFile_1:
	mov	eax, MSG_SENDFILE
	add	eax, CurSendFileID
	call	WSAAsyncSelect, [edi].sendfile_sock, MainWnd, eax, FD_WRITE+FD_CLOSE
	cmp	eax, SOCKET_ERROR
	je	@@SendFile_FAIL_closesocket
	call	lstrcpyn, edi, file, 256
	mov	eax, CurSendFileID
	ret
@@SendFile_FAIL:
	mov	eax, -1
	ret
SendFile	ENDP

END