@ECHO OFF

SET BINDIR=BIN\
SET TMPDIR=TMP\
SET SRCDIR=SRC\
SET INCDIR=SRC\INCLUDE

SET LIB=C:\TASM\LIB\import32.lib
SET TASM=C:\TASM\BIN\TASM32.EXE
SET TLINK=C:\TASM\BIN\TLINK32.EXE

SET TASMFLAG=/ml /m2 /zn /i%INCDIR%
SET TLINKFLAG=-Tpe -aa -n -V4.0 -x

IF "%1"=="clean" GOTO CLEAN

REM *******************BUILD*********************************
:ALL

%TASM% %TASMFLAG% %SRCDIR%winmain.asm      ,%TMPDIR%winmain.obj
%TASM% %TASMFLAG% %SRCDIR%other.asm        ,%TMPDIR%other.obj
%TASM% %TASMFLAG% %SRCDIR%socket.asm       ,%TMPDIR%socket.obj
%TASM% %TASMFLAG% %SRCDIR%winproc.asm      ,%TMPDIR%winproc.obj
%TASM% %TASMFLAG% %SRCDIR%msg_server.asm   ,%TMPDIR%msg_server.obj
%TASM% %TASMFLAG% %SRCDIR%msg_client.asm   ,%TMPDIR%msg_client.obj
%TASM% %TASMFLAG% %SRCDIR%msg_http.asm     ,%TMPDIR%msg_http.obj
%TASM% %TASMFLAG% %SRCDIR%msg_sendfile.asm ,%TMPDIR%msg_sendfile.obj
%TASM% %TASMFLAG% %SRCDIR%http.asm         ,%TMPDIR%http.obj
%TASM% %TASMFLAG% %SRCDIR%sendfile.asm     ,%TMPDIR%sendfile.obj
%TASM% %TASMFLAG% %SRCDIR%command.asm      ,%TMPDIR%command.obj
%TASM% %TASMFLAG% %SRCDIR%op.asm           ,%TMPDIR%op.obj

CD %TMPDIR%
%TLINK% %TLINKFLAG% winmain+socket+winproc+msg_server+msg_client+msg_http+msg_sendfile+command+op+http+sendfile+other, ..\%BINDIR%server.exe, , %LIB%,..\%SRCDIR%remote.def
CD ..
GOTO DONE

REM *******************CLEAN*********************************
:CLEAN
CD %TMPDIR%
DEL *.OBJ
CD ..
GOTO DONE

:DONE
SET BINDIR=
SET TMPDIR=

SET SRCDIR=
SET INCDIR=
SET LIBDIR=
SET TASM=
SET TLINK=

SET TASMFLAG=
SET TLINKFLAG=
