.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

extrn	closesocket	: PROC
extrn	accept		: PROC
extrn	WSAAsyncSelect	: PROC
extrn	send		: PROC

extrn	ServerSock	: DWORD
extrn	ClientPtr	: DWORD

.Data
	HELO_PROMPT	DB	'HELO', 0Dh, 0Ah
	CR_LF		DB	0Dh, 0Ah, 0
	LEN_HELO	EQU	$ - HELO_PROMPT

	ERA_TOOMANYUSER	DB	'Too many user...disconnect', 0
	LEN_TOOMANYUSER	EQU	$ - ERA_TOOMANYUSER

	ERA_SOCKERA	DB	'Windows Socket Error...disconnect', 0
	LEN_SOCKERA	EQU	$ - ERA_SOCKERA
	temp		DD	?

PUBLIC	CR_LF
.Code

; someone waiting for connection ?

PUBLIC		Msg_ServerProc
Msg_ServerProc	PROC, hwnd:DWORD, wmsg:DWORD, wParam:DWORD, lParam:DWORD
	mov	eax, lParam
	cmp	ax, FD_ACCEPT
	je	@@SERV_ACCEPT
	cmp	ax, FD_CLOSE
	jne	@@Msg_ServerProcRet

;*******SERVER: FD_CLOSE*******
	call	closesocket, ServerSock
@@Msg_ServerProcRet:
	ret


;*******SERVER: FD_ACCEPT******
@@SERV_ACCEPT:
	mov	edi, ClientPtr
	xor	ebx, ebx
	xor	ecx, ecx
@@FindFreeClient:
	cmp	[edi+ebx].sock, -1
	je	@@FoundFreeClient
	add	ebx, CLIENTDATA_
	inc	ecx
	cmp	ecx, MAX_CLIENT
	jb	@@FindFreeClient
@@FoundFreeClient:
	mov	wmsg, ecx		; wmsg = ClientID
	add	edi, ebx		; edi -> client

	mov	ebx, edi
	add	ebx, 4100
	mov	temp, SOCKADDR_
	call	accept, ServerSock, ebx, OFFSET temp
	cmp	eax, -1
	je	@@Msg_ServerProcRet
	mov	[edi].sock, eax
	mov	wParam, eax		; wParam = Client[ClientID].sock

	call	send, eax, OFFSET HELO_PROMPT, LEN_HELO, 0

	cmp	wmsg, MAX_CLIENT
	jb	@@login

	mov	esi, OFFSET ERA_TOOMANYUSER
	mov	ecx, LEN_TOOMANYUSER

@@CannotLogin:
	call	send, wParam, esi, ecx, 0
	call	closesocket, wParam
	mov	[edi].sock, -1
	jmp	@@Msg_ServerProcRet

@@login:
	mov	[edi].packetlen, 0
	mov	[edi].telnet_sock, -1

	mov	eax, MSG_SOCKET_CLI
	add	eax, wmsg

	call	WSAAsyncSelect, wParam, hwnd, eax, FD_READ+FD_CLOSE
	or	eax, eax
	jz	@@Msg_ServerProcRet

	mov	esi, OFFSET ERA_SOCKERA
	mov	ecx, LEN_SOCKERA
	jmp	@@CannotLogin

Msg_ServerProc	ENDP

END