.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

WSAEADDRINUSE		EQU	10048

extrn	HeapAlloc	: PROC
extrn	GetLastError	: PROC
extrn	WSAStartup	: PROC
extrn	socket		: PROC
extrn	closesocket	: PROC
extrn	bind		: PROC
extrn	listen		: PROC
extrn	WSAAsyncSelect	: PROC

extrn	MainWnd		: DWORD
extrn	Memory_Heap	: DWORD

.Data
	ServerSock	DD		?
	ServerAddr	SOCKADDR	?
	ServerPort	DD		?
	ClientPtr	DD		0
	LineBuffer	DD		0
	PUBLIC		ServerSock
	PUBLIC		ClientPtr
	PUBLIC		LineBuffer

.Code

; stupid windows dont support network internally,
; so we need to init the network engine.


; RETURN: success:zero
PUBLIC		SocketStart
SocketStart	PROC
	call	HeapAlloc, Memory_Heap, HEAP_GENERATE_EXCEPTIONS, CLIENTDATA_*(MAX_CLIENT+1) + LINE_BUF_SIZE
	or	eax, eax
	jz	@@nomem
	mov	ClientPtr, eax
	add	eax, CLIENTDATA_*(MAX_CLIENT+1)
	mov	LineBuffer, eax

	call	WSAStartup, 0101h, eax
	or	eax, eax
	jnz	@@ret
	mov	eax, 0101h
	mov	esi, LineBuffer
	sub	ax, [esi].wsa_wVersion
@@ret:
	ret
@@nomem:
	mov	al, 1
	ret
SocketStart	ENDP


; setup out server!!
; WARNING!! dont scroll down or you might get headache


; INPUT
;	eax = hwnd
; OUTPUT
;	eax = success:0
PUBLIC			SetSocketHandler
SetSocketHandler	PROC
	push	eax

	mov	edi, ClientPtr
	mov	ecx, MAX_CLIENT
	xor	ebx, ebx
	mov	eax, -1

@@InitVars:
	mov	[edi+ebx].sock, eax
	add	ebx, CLIENTDATA_
	dec	ecx
	jns	@@InitVars

	call	socket, AF_INET, SOCK_STREAM, IPPROTO_TCP
	cmp	eax, -1
	je	@@bad
	mov	ServerSock, eax

	mov	ServerAddr.sa_family, AF_INET
	mov	DWORD PTR ServerAddr.sa_data[2], 0
	mov	ServerPort, REMOTE_PORT

	mov	eax, ServerPort
	mov	ServerAddr.sa_data[0], ah
	mov	ServerAddr.sa_data[1], al

	call	bind, ServerSock, OFFSET ServerAddr, SOCKADDR_
	or	eax, eax
	jz	@@FoundFreePort

@@bad1:
	call	closesocket, ServerSock
@@bad:
	pop	eax
	mov	al, 1
	ret

@@FoundFreePort:
	call	listen, ServerSock, 2
	or	eax, eax
	jnz	@@bad1

	pop	eax
	call	WSAAsyncSelect, ServerSock, eax, MSG_SOCKET_BIND, FD_ACCEPT+FD_CLOSE
	ret
SetSocketHandler	ENDP

END